﻿Imports System
Imports System.Collections.ObjectModel
Imports System.ComponentModel


Public Class FixedLengthCollection(Of T As New)
    Inherits ObservableCollection(Of T)
    Public Sub New(ByVal length As Integer)
        For i = 0 To length - 1
            Me.Add(New T())
        Next i
    End Sub

    Protected Overrides Sub OnPropertyChanged(ByVal args As PropertyChangedEventArgs)
        If args.PropertyName = "Length" Then
            Throw New InvalidOperationException("FixedLengthCollection is of fixed length " & Me.Count)
        End If

        MyBase.OnPropertyChanged(args)
    End Sub
End Class
