﻿Public Class AlmostSquareWave
    Inherits VariableWaveformOscillator
    Private Const INCREMENT As Double = Math.PI / 16

    Public Sub New(ByVal sampleRate As Integer)
        MyBase.New(sampleRate)
        For angle As Double = INCREMENT To 2 * Math.PI - 1 Step INCREMENT
            If angle < Math.PI Then
                Me.Points.Add(New Point(angle, 1))

            ElseIf angle = Math.PI Then
                Me.Points.Add(New Point(angle, 0))

            Else
                Me.Points.Add(New Point(angle, -1))
            End If
        Next angle
    End Sub
End Class
